<?php 
/*********************************************
*	Calendar Lite
*
*	$Author: administrator $
*	$Date: 2003/10/13 12:06:57 $
*	$Revision: 1.1.2.1 $
*
*********************************************/


/*###############################################################
## Mod Title: 	Supporting vars/f(n)s for Calendar Lite Installer
## Mod Version: 1.4.2
## Author: 	WebSnail < Martin Smallridge >
## SUPPORT: 	http://www.snailsource.com/forum/ 
## Description: Variable settings for Calendar.php
##
##
## NOTE: Please read readme.txt
#################################################################*/

$available_dbms = array(
	"mysql" => array(
		"LABEL" => "MySQL 3.x",
		"SCHEMA" => "mysql", 
		"DELIM" => ";",
		"DELIM_BASIC" => ";",
		"COMMENTS" => "remove_remarks"
	), 
	"mysql4" => array(
		"LABEL" => "MySQL 4.x",
		"SCHEMA" => "mysql", 
		"DELIM" => ";", 
		"DELIM_BASIC" => ";",
		"COMMENTS" => "remove_remarks"
	), 
	"postgres" => array(
		"LABEL" => "PostgreSQL 7.x",
		"SCHEMA" => "postgres", 
		"DELIM" => ";", 
		"DELIM_BASIC" => ";",
		"COMMENTS" => "remove_comments"
	), 
	"mssql" => array(
		"LABEL" => "MS SQL Server 7/2000",
		"SCHEMA" => "mssql", 
		"DELIM" => "GO", 
		"DELIM_BASIC" => ";",
		"COMMENTS" => "remove_comments"
	),
	"msaccess" => array(
		"LABEL" => "MS Access [ ODBC ]",
		"SCHEMA" => "", 
		"DELIM" => "", 
		"DELIM_BASIC" => ";",
		"COMMENTS" => ""
	),
	"mssql-odbc" =>	array(
		"LABEL" => "MS SQL Server [ ODBC ]",
		"SCHEMA" => "mssql", 
		"DELIM" => "GO",
		"DELIM_BASIC" => ";",
		"COMMENTS" => "remove_comments"
	)
);


function cal_update_err($error) {
	global $lang, $template;

	$template->assign_block_vars('switch_error_install', array());

	$template->assign_vars(array(
		"L_ERROR_TITLE" => $lang['Installer_Error'],
		"L_ERROR" => $lang['Error'] . "<br />" . $error)
	);
	$template->pparse('body');
	exit;
}


function install_sql($schema_file, $report='') {
	global $db, $template, $lang, $dbms, $available_dbms, $table_prefix, $tablename;

	$remove_remarks = $available_dbms[$dbms]['COMMENTS'];;
	$delimiter = $available_dbms[$dbms]['DELIM']; 
	$delimiter_basic = $available_dbms[$dbms]['DELIM_BASIC'];


	// Carry out various test to make sure all the info is there... 
	if(!file_exists($schema_file)) {
		$report .= "<font color=red><b>Could not locate SQL schema file</b>: $schema_file";
		cal_update_err($report);
	}
	$test_open = @fopen($schema_file, 'r');
	if(!$test_open) {
		$report .= "<font color=red><b>Could not open SQL schema file.</b> $schema_file <br />Check file exists and file permissions";
		cal_update_err($report);
	}
	fclose($test_open);
	$sql_query = @fread(@fopen($schema_file, 'r'), @filesize($schema_file));
	if(!sql_query) {
		$report .= "<font color=red><b>Could not read SQL schema file.</b> $schema_file <br />Check file exists and file permissions";
		cal_update_err($report);
	}

	$sql_query = preg_replace('/phpbb_/', $table_prefix, $sql_query);
	$sql_query = $remove_remarks($sql_query);
	$sql_query = split_sql_file($sql_query, $delimiter);

	$sql_count = count($sql_query);

	for($i = 0; $i < $sql_count; $i++) {
		$result = $db->sql_query($sql_query[$i]);
		if( !$result ) {
			$error = $db->sql_error();
			$report .= $error['message'];

			$template->assign_block_vars('switch_error_install', array());

			$template->assign_vars(array(
				"L_ERROR_TITLE" => $lang['Installer_Error'],
				"L_ERROR" => $lang['Install_db_error'] . '<br />' . $report)
			);
			$template->pparse('body');
			exit;
		}
	}
	return;
}

function go_sql($sql, $report) {
	// Run an SQL command and return $report on success or display current report to date as error message.

	global $db, $template, $lang;
	for ($i=0; $i< count($sql); $i++) {
		if(!$result = $db->sql_query($sql[$i])) {
			$error = $db->sql_error();
			$report .= '<font color=red><B>Could not complete SQL command </b><br />'.$sql[$i].'</font><br /><b>ERROR:</b> '.$error['message'].'<br /><br />';
			cal_update_err($report);
		}
		else {
			$report .= "SQL Command: '".$sql[$i]."' (<font color=green><b>Done</b></font>)<br />";		
		}
	}
	return $report;
}

?>